#ifndef VTKCPVTKPIPELINE_H
#define VTKCPVTKPIPELINE_H

#include <vtkCPPipeline.h>
#include <string>
#include <vtkLiveInsituLink.h>     

class vtkCPProcessor;
class vtkCPDataDescription;
class vtkCPPythonHelper;
class vtkPVTrivialProducer;

class vtkCPVTKPipeline : public vtkCPPipeline
{
public:
  static vtkCPVTKPipeline* New();
  vtkTypeMacro(vtkCPVTKPipeline,vtkCPPipeline);
  virtual void PrintSelf(ostream& os, vtkIndent indent);

  virtual void Initialize();

  virtual int RequestDataDescription(vtkCPDataDescription* dataDescription);

  virtual int CoProcess(vtkCPDataDescription* dataDescription);
  vtkPVTrivialProducer* input;
 
protected:
  vtkCPVTKPipeline();
  virtual ~vtkCPVTKPipeline();
  

private:
  vtkCPVTKPipeline(const vtkCPVTKPipeline&); // Not implemented
  void operator=(const vtkCPVTKPipeline&); // Not implemented

  int OutputFrequency;
};

extern vtkCPProcessor* Processor;
extern vtkLiveInsituLink* LiveLink;

void Init();
void CatalystCoProcess(int timeStep, double time, unsigned int numPoints[3], double spacing[3], double* field);
int Closeall(void);
#endif
